<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\property;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\property\PropertyHead;
use app\common\model\property\PropertyOrder;
use app\common\lists\ListsSearchInterface;
use app\common\model\property\PropertyUser;
use app\common\model\works\ServiceWork;
use think\facade\Db;


/**
 * PropertyOrderAnalysis列表
 * Class PropertyOrderAnalysis
 * @package app\adminapi\lists
 */
class PropertyOrderAnalysis extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function setSearch(): array
    {
        return [
        ];
    }
    public function queryWhere()
    {
        $where = [];
        isset($this->params['property_name']) && !empty($this->params['property_name']) && $where[] = ['c.property_name', 'LIKE', '%'.$this->params['property_name'].'%'];
        isset($this->params['village_name']) && !empty($this->params['village_name']) && $where[] = ['c.village_name', 'LIKE', '%'.$this->params['village_name'].'%'];
        isset($this->params['head_name']) && !empty($this->params['head_name']) && $where[] = ['c.head_name', 'LIKE', '%'.$this->params['head_name'].'%'];
        isset($this->params['head_mobile']) && !empty($this->params['head_mobile']) && $where[] = ['c.head_mobile', '=', $this->params['head_mobile']];
        if(isset($this->params['start_month']) && $this->params['start_month']){
            $startDateTime = strtotime($this->params['start_month']);
            $endDateTime = strtotime('+1 month', $startDateTime)-1;
            $where[] = ['b.finished_time','BETWEEN',[$startDateTime,$endDateTime]];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function lists(): array
    {
        $res =   Db::name('property_order')->alias('a')
            ->field(['c.id','c.head_name','c.property_name','c.village_name',
                Db::raw('DATE_FORMAT(FROM_UNIXTIME(b.finished_time), "%Y-%m") AS month_format,COUNT(b.id) as month_num, SUM(b.work_amount) as month_amount')
            ])
            ->leftJoin('service_work b', 'a.work_id = b.id')
            ->leftJoin('property_head c', 'a.property_head_id = c.id')
            ->where([['b.work_pay_status','=',2],['b.approval','=',1]])
            ->where('b.finished_time','>',0)
            ->where($this->queryWhere())
            ->group('a.property_head_id,month_format')
            ->limit($this->limitOffset, $this->limitLength)
            ->select()->toArray();
        return $res;
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function count(): int
    {
        return ServiceWork::where([['work_pay_status','=',2],['approval','=',1]])
            ->where('finished_time','>',0)
            ->where('user_id','>',0)
            ->where($this->queryWhere())
            ->count();
    }

}